summaryrefslogtreecommitdiff
path: root/tests/misc
diff options
context:
space:
mode:
authorJim Meyering <meyering@redhat.com>2010-11-27 15:50:43 +0100
committerJim Meyering <meyering@redhat.com>2010-11-27 16:32:06 +0100
commitfbb47bf42457f8126cc128ff2c4590ad34d5e730 (patch)
tree0d4f5bb2ebb3ff0442148022246fee832bad799c /tests/misc
parentb8cd747cc8039237ec17482e984847df08b10291 (diff)
downloadcoreutils-fbb47bf42457f8126cc128ff2c4590ad34d5e730.tar.xz
tests: test for parallel sort spinlock abuse
* tests/misc/sort-spinlock-abuse: New file. * tests/Makefile.am (TESTS): Add it. (XFAIL_TESTS): Mark this as an expected-to-fail (for now) test.
Diffstat (limited to 'tests/misc')
-rwxr-xr-xtests/misc/sort-spinlock-abuse37
1 files changed, 37 insertions, 0 deletions
diff --git a/tests/misc/sort-spinlock-abuse b/tests/misc/sort-spinlock-abuse
new file mode 100755
index 000000000..974e3d5c6
--- /dev/null
+++ b/tests/misc/sort-spinlock-abuse
@@ -0,0 +1,37 @@
+#!/bin/sh
+# trigger a bug that would make parallel sort use 100% of one or more
+# CPU while blocked on output.
+
+# Copyright (C) 2010 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+. "${srcdir=.}/init.sh"; path_prepend_ ../src
+print_ver_ sort
+
+test "$(nproc)" = 1 && skip_ "requires a multi-core system"
+
+seq 100000 > in || framework_failure_
+mkfifo fifo || framework_failure_
+
+# Arrange for sort to require 1.2+ seconds of wall-clock time,
+# while actually using far less than 1 second of CPU time.
+(for i in $(seq 12); do read line; echo $i; sleep .1; done
+ cat > /dev/null) < fifo &
+
+# Limit CPU time to 1 second
+ulimit -t 1
+sort --parallel=2 in > fifo || fail=1
+
+Exit $fail